//===----------------------------------------------------------------------===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//

// <list>

// void assign(initializer_list<value_type> il);

#include <list>
#include <cassert>

int main()
{
#ifdef _LIBCPP_MOVE
    std::list<int> d;
    d.assign({3, 4, 5, 6});
    assert(d.size() == 4);
    std::list<int>::iterator i = d.begin();
    assert(*i++ == 3);
    assert(*i++ == 4);
    assert(*i++ == 5);
    assert(*i++ == 6);
#endif
}
