//===-- CommandObjectSettings.h ---------------------------------*- C++ -*-===//
//
//                     The LLVM Compiler Infrastructure
//
// This file is distributed under the University of Illinois Open Source
// License. See LICENSE.TXT for details.
//
//===----------------------------------------------------------------------===//

#ifndef liblldb_CommandObjectSettings_h_
#define liblldb_CommandObjectSettings_h_

// C Includes
// C++ Includes
// Other libraries and framework includes
// Project includes
#include "lldb/Interpreter/CommandObject.h"

namespace lldb_private {

//-------------------------------------------------------------------------
// CommandObjectSettings
//-------------------------------------------------------------------------

class CommandObjectSettings : public CommandObject
{
public:

    CommandObjectSettings ();

    virtual
    ~CommandObjectSettings ();

    virtual bool
    Execute (CommandInterpreter &interpreter,
             Args& command,
             CommandReturnObject &result);

};

} // namespace lldb_private

#endif  // liblldb_CommandObjectSettings_h_
